/* server.cmdline.h */

/* File autogenerated by gengetopt version 2.13.1  */

#ifndef SERVER_CMDLINE_H
#define SERVER_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
#define CMDLINE_PARSER_PACKAGE "para_server"
#endif

#ifndef CMDLINE_PARSER_VERSION
#define CMDLINE_PARSER_VERSION "(paraslash 0.2.2, tangential excitation)\nCopyright (c) 1997-2005 by Andre Noll\nThis is free software with ABSOLUTELY NO WARRANTY. See COPYING for details."
#endif

struct gengetopt_args_info
{
  int loglevel_arg;	/* set loglevel (0-6) (default='4').  */
  int port_arg;	/* port to listen on (default='2990').  */
  int daemon_flag;	/* run as background daemon (default=off).  */
  char * user_arg;	/* run as user 'username'. para_server does not need any special privileges. If started as root (EUID == 0) this option must be given at the command line (not in the configuration file) so that para_server can drop the root privileges right after parsing the command line options, but before parsing the configuration file. In this case, real/effective/saved UID are all set to the UID of 'username'. As the configuration file is read afterwards, those options that have a default value depending on the UID (e.g. the home directory for the configuration file) are computed by using the uid of 'username'. This option has no effect if para_server ist started as a non-root user (i.e.  EUID != 0).  */
  char * logfile_arg;	/* (default=stdout/stderr).  */
  char * config_file_arg;	/* (default='~/.paraslash/server.conf'.  */
  char * user_list_arg;	/* (default='~/.paraslash/server.users').  */
  char ** stream_write_cmd_arg;	/* Program to pipe encoded audio data to. This option can be given multiple times. Syntax is 'format:command'. (default='mp3:para_send HOME()/.paraslash/server_mp3_fifo.HOSTNAME()' and 'ogg:para_send --header_len HEADER_LEN() HOME()/.paraslash/server_ogg_fifo.HOSTNAME(). The three macros HOME(), HOSTNAME() and HEADER_LEN() are substituted by appropriate values detected at runtime').  */
  int autoplay_flag;	/* start playing on startup (default=off).  */
  char * dbtool_arg;	/* (default=first available that works).  */
  char * mysql_host_arg;	/* mysql server (default='localhost').  */
  int mysql_port_arg;	/* where mysql is listening (default='3306').  */
  char * mysql_user_arg;	/* default value: username from /etc/passwd.  */
  char * mysql_passwd_arg;	/* (required).  */
  char * mysql_database_arg;	/* name of mysql database (default='paraslash').  */
  char * mysql_find_cmd_arg;	/* cmd to locate sound files (required).  */
  char * mysql_default_score_arg;	/* scoring rule to use if stream definition does not contain explicit score definition (default='(LASTPLAYED() / 1440 - 1000 / (LASTPLAYED() + 1) - sqrt(NUMPLAYED()))').  */
  char * dopey_dir_arg;	/* dir to search for files to be streamed (default='/home/music').  */
  
  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int loglevel_given ;	/* Whether loglevel was given.  */
  int port_given ;	/* Whether port was given.  */
  int daemon_given ;	/* Whether daemon was given.  */
  int user_given ;	/* Whether user was given.  */
  int logfile_given ;	/* Whether logfile was given.  */
  int config_file_given ;	/* Whether config_file was given.  */
  int user_list_given ;	/* Whether user_list was given.  */
  unsigned int stream_write_cmd_given ;	/* Whether stream_write_cmd was given.  */
  int autoplay_given ;	/* Whether autoplay was given.  */
  int dbtool_given ;	/* Whether dbtool was given.  */
  int mysql_host_given ;	/* Whether mysql_host was given.  */
  int mysql_port_given ;	/* Whether mysql_port was given.  */
  int mysql_user_given ;	/* Whether mysql_user was given.  */
  int mysql_passwd_given ;	/* Whether mysql_passwd was given.  */
  int mysql_database_given ;	/* Whether mysql_database was given.  */
  int mysql_find_cmd_given ;	/* Whether mysql_find_cmd was given.  */
  int mysql_default_score_given ;	/* Whether mysql_default_score was given.  */
  int dopey_dir_given ;	/* Whether dopey_dir was given.  */

  char **inputs ; /* unamed options */
  unsigned inputs_num ; /* unamed options number */
} ;

int cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info);
int cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required);

void cmdline_parser_print_help(void);
void cmdline_parser_print_version(void);

void cmdline_parser_init (struct gengetopt_args_info *args_info);
void cmdline_parser_free (struct gengetopt_args_info *args_info);

int cmdline_parser_configfile (char * const filename, struct gengetopt_args_info *args_info, int override, int initialize, int check_required);

int cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* SERVER_CMDLINE_H */
